-- to do
-- chat filter needs FR/DE strings
-- need gender specific values :(

-- filtering
-- sorting

function loadData()
	factionRep=PatchDataLoad( Turbine.DataScope.Server, "AltViewer_FactionRep");
	if factionRep==nil then
		factionRep=PatchDataLoad( Turbine.DataScope.Server, "AltInventory_FactionRep");
		if factionRep~=nil then
			-- adjust rep up one tier for "Enemy" (faction) and "Initiate" (guild)
			for k,v in pairs(factionRep) do
				for faction,rep in ipairs(v.Rep) do
					if rep==nil then
						v.Rep[faction]=0
					elseif rep>0 then
						v.Rep[faction]=rep+1;
					end
				end
			end
		end
	end
	if factionRep==nil then
		factionRep={};
	end
end

factions={};
factions[1]={1,{"The Ale Association","La Confr\195\169rie de la cervoise","Die Bier-Genossenschaft"},false,1};
factions[2]={2,{"The Eldgang","Les Eldgangs","Die Eldgang"},false,1};
factions[3]={3,{"Council of the North","Conseil du Nord","Rat des Nordens"},false,1};
factions[4]={4,{"Men of Bree","Hommes de Bree","Menschen von Bree"},false,1};
factions[5]={5,{"Algraig, Men of Enedwaith","Les Algraig, Hommes d'Enedwaith","Algraig, Menschen von Enedwaith"},false,1};
factions[6]={6,{"The Grey Company","La Compagnie Gris","Die Graue Schar"},false,1};
factions[7]={7,{"Thorin's Hall","Palais de Thorin","Thorins Halle"},false,1};
factions[8]={8,{"The Wardens of Ann\195\186minas","Les Gardiens d'Annuminas","Die H\195\188ter von Ann\195\186minas"},false,1};
factions[9]={9,{"Lossoth of Forochel","Lossoth du Forochel","Lossoth von Forochel"},false,1};
factions[10]={10,{"The Eglain","Les Eglain","Die Eglain"},false,1};
factions[11]={11,{"Galadhrim","Galadhrim","Galadhrim"},false,1};
factions[12]={12,{"Malledhrim","Malledhrim","Malledhrim"},false,1};
factions[13]={13,{"Rangers of Esteld\195\173n","R\195\180deurs d'Esteldin","Waldl\195\164ufer von Esteld\195\173n"},false,1};
factions[14]={14,{"Elves of Rivendell","Elfes de Fondcombe","Elben von Bruchtal"},false,1};
factions[15]={15,{"The Mathom Society","La Soci\195\169t\195\169 des Mathoms","Die Mathom-Gesellschaft"},false,1};
factions[16]={16,{"The Inn League","La Ligue des Tavernes", "Die Gasthausliga"},false,1};
factions[17]={22,{"The Riders of Stangard","Les Cavaliers de Stangard","Die Reiter von Stangard"},false,1};
factions[18]={23,{"Heros of Limlight Gorge","Les H\195\169ros de la Gorge du Limeclair","Helden der Limklar-Schlucht"},false,1};
factions[19]={17,{"Iron Garrison Guards","Gardes de la Garnison de Fer","W\195\164chter der Eisernen Garnison"},false,1};
factions[20]={18,{"Iron Garrison Miners","Mineurs de la Garnison de Fer","Minenbauer der Eisernen Garnison"},false,1};
factions[21]={19,{"Men of Dunland","Hommes du Pays de Dun","Menschen aus Dunland"},false,1};
factions[22]={20,{"Th\195\169odred's Riders","Les Cavaliers de Th\195\169odred","Th\195\169odreds Reiter"},false,1};
factions[23]={24,{"Men of the Wold","Hommes du Plateau","Menschen der Steppe"},false,1};
factions[24]={25,{"Men of the Norcrofts","Hommes des Norcrofts","Menschen der Norhofen"},false,1};
factions[25]={26,{"Men of the Sutcrofts","Hommes des Sutcrofts","Menschen der Suthofen"},false,1};
factions[26]={27,{"Men of the Entwash Vale","Hommes de la vall\195\169e de l'Entalluve","Menschen des Entwasser-Tals"},false,1};
factions[27]={21,{"Guild"},true,2};
for k,v in ipairs(factions) do
	if v[2][2]==nil then v[2][2]=v[2][1] end
	if v[2][3]==nil then v[2][3]=v[2][1] end
end
factionCount=#factions;

craftGuild={}
craftGuild[1]={"<Select Guild>","Cook's Guild","Jeweller's Guild","Metalsmith's Guild","Scholar's Guild","Tailor's Guild","Weaponsmith's Guild","Woodworker's Guild"};
craftGuild[2]={"<Slectionnez guilde>","Guilde des Cuisiniers","Guilde des bijoutiers","Guilde des ferronniers","Guilde des \195\169rudits","Guilde des tailleurs","Guilde des fabricants d'armes","Guilde des menuisiers"};
craftGuild[3]={"<Whlen Gilde>","Kochgilde","Goldschmiedegilde","Schmiedegilde","Gelehrtengilde","Schneidergilde","Waffenschmiedegilde","Drechslergilde"};

factionTier={}
factionTier[1]={};
factionTier[2]={};
factionTier[1]["M"]={{"Enemy",nil,nil},{"Outsider","Etrang\195\168re","Au\195\159enseiter"},{"Neutral",Neutre,"Neutral"},{"Acquaintance","Connaissance","Bekkanter"},{"Friend","Ami","Freund"},{"Ally","Alli\195\169","Verb\195\188ndeter"},{"Kindred","Fr\195\168re","Verwandter"}};
factionTier[1]["F"]={{"Enemy",nil,nil},{"Outsider","Etrang\195\168re","Au\195\159enseiter"},{"Neutral",Neutre,"Neutral"},{"Acquaintance","Connaissance","Bekkanter"},{"Friend","Amie","Freund"},{"Ally","Alli\195\169","Verb\195\188ndeter"},{"Kindred","S\197\147ur","Verwandter"}};

factionTier[2]["M"]={{"Guild Initiate","Initi\195\169 de la guilde","Eingeweihter der Gilde"},{"Apprentice of the Guild",nil,nil},{"Journeyman of the Guild","Compagnon de la guilde","Geselle der Gilde"},{"Expert of the Guild",nil,nil},{"Artisan of the Guild","Artisan de la guilde","Virtuose der Gilde"},{"Master of the Guild",nil,"Meister der Guilde"},{"Grand Master of the Guild","Gande ma\195\174tre de la guilde","Gro\195\159meister der Gilde"}}; -- Guild Tiers are different
factionTier[2]["F"]={{"Guild Initiate","Initi\195\169 de la guilde","Eingeweihter der Gilde"},{"Apprentice of the Guild",nil,nil},{"Journeyman of the Guild","Compagnon de la guilde","Geselle der Gilde"},{"Expert of the Guild",nil,nil},{"Artisan of the Guild","Artisan de la guilde","Virtuose der Gilde"},{"Master of the Guild",nil,"Meisterin der Gilde"},{"Grand Master of the Guild","Gande ma\195\174tre de la guilde","Gro\195\159\meisterin der Gilde"}}; -- Guild Tiers are different

-- french tiers for Ally and Kindred are gender specific :(
-- (M)   nil,Etrang\195\168re,Neutre,Connaissance,Ami,Alli\195\169, Fr\195\168re
-- (F) nil,Etrang\195\168re,Neutre,Connaissance,Amie,Alli\195\169, S\197\147ur
-- nil,Au\195\159enseiter,Neutral,Bekkanter,Freund,Verb\195\188ndeter ,Verwandter

-- german master/grandmaster are gender specific
-- Initi\195\169 de la guilde,,Compagnon de la guilde,,Artisan de la guilde,,Gande ma\195\174tre de la guilde
--(M) Eingeweihter der Gilde,,Geselle der Guilde,,Virtuose der Gilde,Meister der Guilde,Gro\195\159meister der Gilde
--(F) ,,,,,Meisterin der Gilde,Gro\195\159\meisterin der Gilde

-- fill in nil values using EN value
for type,data1 in ipairs(factionTier) do
	for gender,data2 in pairs(data1) do
		for tier,data3 in ipairs(data2) do
			if data3[2]==nil then factionTier[type][gender][tier][2]=data3[1] end
			if data3[3]==nil then factionTier[type][gender][tier][3]=data3[1] end
		end
	end
end
loadData();

RepPanel=Turbine.UI.Control()
RepPanel:SetMouseVisible(false);
RepPanel:SetSize(200,200);

-- create panel controls
RepPanel.VP=Turbine.UI.Control();
RepPanel.VP:SetSize(190,60*factionCount+100); -- we pad the bottom by 100 to allow enough room for the drop down lists
RepPanel.VP:SetParent(RepPanel);
RepPanel.GuildFaction=20;
RepPanel.FactionCaption={};
RepPanel.FactionList={};
RepPanel.FactionBack={};
for tmpIndex,tmpFaction in ipairs(factions) do
	local tmpGender=charList[selectedCharName].Gender
	if tmpGender==nil then tmpGender="M" end
	RepPanel.FactionBack[tmpIndex]=Turbine.UI.Control();
	RepPanel.FactionBack[tmpIndex]:SetSize(265,28);
	RepPanel.FactionBack[tmpIndex]:SetBackground(0x41005f97);
	RepPanel.FactionBack[tmpIndex]:SetBlendMode(Turbine.UI.BlendMode.Overlay);
	RepPanel.FactionBack[tmpIndex]:SetParent(RepPanel.VP);
	RepPanel.FactionBack[tmpIndex]:SetPosition(0,(tmpIndex-1)*60+22);
	if tmpFaction[3] then
		RepPanel.GuildFaction=tmpIndex;
		RepPanel.FactionCaption[tmpIndex]=DropDownList();
		for tmpGuildIndex, tmpName in ipairs(craftGuild[language]) do
			RepPanel.FactionCaption[tmpIndex]:AddItem(tmpName,tmpGuildIndex-1);
			RepPanel.FactionCaption[tmpIndex].ListData:GetItem(tmpGuildIndex):SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter);
		end
		RepPanel.FactionCaption[tmpIndex].CurrentValue:SetTextAlignment(Turbine.UI.ContentAlignment.BottomCenter);
		RepPanel.FactionCaption[tmpIndex]:SetSelectedIndex(1);
		RepPanel.FactionCaption[tmpIndex].SelectedIndexChanged=function(sender,args)
			factionRep[selectedCharName]["Guild"]=RepPanel.FactionCaption[RepPanel.GuildFaction]:GetValue();
			RepPanel.FactionList[RepPanel.GuildFaction]:SetVisible((factionRep[selectedCharName]["Guild"]~=0));
		end
	else
		RepPanel.FactionCaption[tmpIndex]=Turbine.UI.Label();
		RepPanel.FactionCaption[tmpIndex]:SetHeight(25);
		RepPanel.FactionCaption[tmpIndex]:SetText(tmpFaction[2][language]);
		RepPanel.FactionCaption[tmpIndex]:SetTextAlignment(Turbine.UI.ContentAlignment.BottomCenter);
	end
	RepPanel.FactionCaption[tmpIndex]:SetParent(RepPanel.VP);
	RepPanel.FactionCaption[tmpIndex]:SetPosition(0,(tmpIndex-1)*60);
	RepPanel.FactionCaption[tmpIndex]:SetWidth(RepPanel:GetWidth()-12);
	RepPanel.FactionCaption[tmpIndex]:SetFont(Turbine.UI.Lotro.Font.Verdana16);
	RepPanel.FactionList[tmpIndex]=DropDownList();
	RepPanel.FactionList[tmpIndex]:SetParent(RepPanel.VP);
	RepPanel.FactionList[tmpIndex]:SetWidth(190);
	RepPanel.FactionList[tmpIndex]:SetFont(Turbine.UI.Lotro.Font.Verdana14);
	RepPanel.FactionList[tmpIndex]:SetPosition(19,(tmpIndex-1)*60+28);
	RepPanel.FactionList[tmpIndex].FactionID=tmpFaction[1]; -- just in case we need to add a faction within the display order
	RepPanel.FactionList[tmpIndex].CurrentValue:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
	RepPanel.FactionList[tmpIndex]:AddItem("<"..Resource[language][23]..">",0);
	for tmpTier, tmpName in ipairs(factionTier[tmpFaction[4]][tmpGender]) do
		RepPanel.FactionList[tmpIndex]:AddItem(tmpName[language],tmpTier);
	end
	local tmpTier;
	for tmpTier=1,RepPanel.FactionList[tmpIndex].ListData:GetItemCount() do
		RepPanel.FactionList[tmpIndex].ListData:GetItem(tmpTier):SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter);
	end
	RepPanel.FactionList[tmpIndex]:SetDropRows(#factionTier[tmpFaction[4]][tmpGender]+1);
	RepPanel.FactionList[tmpIndex]:SetSelectedIndex(2);
	RepPanel.FactionList[tmpIndex].SelectedIndexChanged=function(sender,args)
		-- update the factionRep table
		factionRep[selectedCharName]["Rep"][sender.FactionID]=sender:GetValue();
	end
end
	
RepPanel.VScroll=Turbine.UI.Lotro.ScrollBar();
RepPanel.VScroll:SetOrientation(Turbine.UI.Orientation.Vertical);
RepPanel.VScroll:SetParent(RepPanel);
RepPanel.VScroll:SetPosition(RepPanel:GetWidth()-12,0);
RepPanel.VScroll:SetWidth(12);
RepPanel.VScroll:SetHeight(200);
RepPanel.VScroll:SetMinimum(0);
RepPanel.VScroll.ValueChanged=function(sender,args)
	RepPanel.VP:SetTop(-RepPanel.VScroll:GetValue());
end

RepPanel:SetVisible(false);

RepPanel.LoadCharData=function()
	if charList[selectedCharName].Alignment==Turbine.Gameplay.Alignment.FreePeople then
		if factionRep[selectedCharName]==nil then
			factionRep[selectedCharName]={};
			factionRep[selectedCharName]["Guild"]=0; -- undefined - there is no Prospector or Forester guild
			factionRep[selectedCharName]["Rep"]={0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0};
		end

		for tmpIndex,tmpFaction in ipairs(factions) do
			if tmpFaction[3] then
				-- guild faction, treat it "specially"
				local guild=factionRep[selectedCharName]["Guild"];
				if guild==nil then guild=0 end
				RepPanel.FactionCaption[tmpIndex]:SetSelectedIndex(guild+1); -- increment to account for the "<Select>" option at index 1
				RepPanel.FactionList[tmpIndex]:SetVisible((guild~=0));
			end
			if factionRep[selectedCharName]["Rep"][RepPanel.FactionList[tmpIndex].FactionID]~=nil then
				RepPanel.FactionList[tmpIndex]:SetSelectedIndex(factionRep[selectedCharName]["Rep"][RepPanel.FactionList[tmpIndex].FactionID]+1);
			else
				RepPanel.FactionList[tmpIndex]:SetSelectedIndex(1);
			end
		end
	end
	-- we need to call SetLanguage so that we can change any gender specific list entries for the selected character
	RepPanel.SetLanguage()
end
RepPanel.Show=function()
	if charList[selectedCharName].Alignment==Turbine.Gameplay.Alignment.FreePeople then
		mainWindow.InvalidMsg:SetVisible(false);
		RepPanel:SetVisible(true);
	else
		mainWindow.InvalidMsg:SetText(Resource[language][102]);
		mainWindow.InvalidMsg:SetVisible(true);
		RepPanel:SetVisible(false);
	end	
end

RepPanel.SaveData=function()
	PatchDataSave( Turbine.DataScope.Server, "AltViewer_FactionRep",factionRep);
end

RepPanel.RemoveCallbacks=function()
	RemoveCallback(Turbine.Chat,"Received",RepPanel.ChatHandler);
end
RepPanel.RemoveCharacter=function(characterName)
	factionRep[characterName]=nil;
end

RepPanel.SizeChanged=function(sender,args)
	local newWidth,newHeight=mainWindow.PanelBack:GetSize();

	Turbine.UI.Control.SetSize(RepPanel,newWidth,newHeight);
	RepPanel.VScroll:SetLeft(newWidth-12);
	RepPanel.VScroll:SetHeight(newHeight);
	RepPanel.VP:SetWidth(newWidth-12);
	local tmpIndex;
	for tmpIndex=1,factionCount do
		RepPanel.FactionCaption[tmpIndex]:SetWidth(newWidth-12);
		RepPanel.FactionBack[tmpIndex]:SetLeft((newWidth-RepPanel.FactionBack[tmpIndex]:GetWidth()-12)/2);
		RepPanel.FactionList[tmpIndex]:SetLeft((newWidth-192)/2);
	end
	if RepPanel.VScroll:GetValue()>RepPanel.VScroll:GetMaximum() then
		RepPanel.VSCroll:SetValue(RepPanel.VSCroll:GetMaximum());
	end
	if RepPanel:GetHeight()<RepPanel.VP:GetHeight() then
		RepPanel.VScroll:SetMaximum(RepPanel.VP:GetHeight()-RepPanel:GetHeight());
		RepPanel.VP:SetTop(-RepPanel.VScroll:GetValue());
		RepPanel.VScroll:SetVisible(true);
	else
		RepPanel.VScroll:SetValue(0);
		RepPanel.VScroll:SetVisible(false);
	end
end
RepPanel.SetLanguage=function()
	local tmpGender=charList[selectedCharName].Gender
	if tmpGender==nil then tmpGender="M" end
	for tmpIndex,tmpFaction in ipairs(factions) do
		local selIndex
		if tmpFaction[3] then
			selIndex=RepPanel.FactionCaption[tmpIndex]:GetSelectedIndex();
			for lblIndex=1,RepPanel.FactionCaption[tmpIndex].ListData:GetItemCount() do
				RepPanel.FactionCaption[tmpIndex].ListData:GetItem(lblIndex):SetText(craftGuild[language][lblIndex])
			end
			RepPanel.FactionCaption[tmpIndex].CurrentValue:SetText(craftGuild[language][selIndex])
		else
			RepPanel.FactionCaption[tmpIndex]:SetText(tmpFaction[2][language]);
		end
		selIndex=RepPanel.FactionList[tmpIndex]:GetSelectedIndex();
		RepPanel.FactionList[tmpIndex].ListData:GetItem(1):SetText("<"..Resource[language][23]..">")
		for lblIndex=2,RepPanel.FactionList[tmpIndex].ListData:GetItemCount() do
			RepPanel.FactionList[tmpIndex].ListData:GetItem(lblIndex):SetText(factionTier[tmpFaction[4]][tmpGender][lblIndex-1][language])
		end
		if selIndex==1 then
			RepPanel.FactionList[tmpIndex].CurrentValue:SetText("<"..Resource[language][23]..">")
		else
			RepPanel.FactionList[tmpIndex].CurrentValue:SetText(factionTier[tmpFaction[4]][tmpGender][selIndex-1][language])
		end
	end
end

RepPanel.SetColors=function()
	RepPanel:SetBackColor(settings.BackColor);
	for tmpIndex,tmpFaction in ipairs(factions) do
		if tmpFaction[3] then
			RepPanel.FactionCaption[tmpIndex]:SetTextColor(settings.ListTextColor);
			RepPanel.FactionCaption[tmpIndex]:SetBorderColor(settings.TrimColor);
			RepPanel.FactionCaption[tmpIndex]:SetBackColor(settings.BackColor);
			RepPanel.FactionCaption[tmpIndex]:SetCurrentBackColor(settings.BackColor);
		else
			RepPanel.FactionCaption[tmpIndex]:SetForeColor(settings.ForeColor);
		end
		RepPanel.FactionList[tmpIndex]:SetBorderColor(settings.BackColor);
		RepPanel.FactionList[tmpIndex]:SetBackColor(Turbine.UI.Color(.1,.1,.2));
		RepPanel.FactionList[tmpIndex]:SetCurrentBackColor(Turbine.UI.Color(.02,.07,.18));
		RepPanel.FactionList[tmpIndex]:SetTextColor(settings.ListTextColor);
	end
	RepPanel.VP:SetBackColor(settings.BackColor);
	RepPanel.VScroll:SetBackColor(settings.BackColor);
end
for tmpIndex,tmpFaction in ipairs(factions) do
	if tmpFaction[3] then
		RepPanel.FactionCaption[tmpIndex]:SetZOrder((factionCount-tmpIndex)*2+2)
	end
	RepPanel.FactionList[tmpIndex]:SetZOrder((factionCount-tmpIndex)*2+1)
end

-- add a chat listener on Advancement messages for the form of:
-- AdvancementPattern="Your standing with (.*) is now (.*)%..*"

-- need to catch the guild advancement messages

if locale=="en" then
	RepAdvancementPattern="Your standing with (.*) is now (.*)%..*";
elseif locale=="fr" then
	RepAdvancementPattern="Your standing with (.*) is now (.*)%..*";
else
	RepAdvancementPattern="Your standing with (.*) is now (.*)%..*";
end
RepPanel.ChatHandler=function(sender,args)
	if args.ChatType==Turbine.ChatType.Advancement or args.ChatType==Turbine.ChatType.Standard then
		local tmpFaction,tmpTier=string.match(args.Message,RepAdvancementPattern);
		if tmpFaction~=nil then
			-- whooohooo! we got a faction advancement message!
			-- gonna be hard to test this one :(  perhaps create a new character for each test and use up the rep items in the shared vault
			local tmpIndex,factionID,tierID;
			tmpLanguage=1;
			if locale=="fr" then
				tmpLanguage=2
			elseif locale=="de" then
				tmpLanguage=3
			end
			for k, v in ipairs(factions) do
				if v[2][tmpLanguage]==tmpFaction then
					factionID=v[1];
					break;
				end
			end
			if factionID~=nil then
				for k,v in ipairs(factionTier[faction[factionID][4]]["M"]) do
					if v[tmpLanguage]==tmpTier then
						tierID=k;
						break;
					end
				end
				if tierID==nil then
					for k,v in ipairs(factionTier[faction[factionID][4]]["F"]) do
						if v[tmpLanguage]==tmpTier then
							tierID=k;
							break;
						end
					end
				end
				if tierID~=nil then
					factionRep[charName]["Rep"][factionID]=tierID
					if charName==selectedCharName then
						RepPanel:LoadCharData()
					end
				end
			end
		end
	end
end
AddCallback(Turbine.Chat,"Received",RepPanel.ChatHandler);

--Your standing with Cook's Guild is now Apprentice of the Guild.
--Your standing with Cook's Guild is now Journeyman of the Guild.
--Your standing with Men of Dunland is now Kindred.